﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MenuLibrary;

namespace ConsoleApp
{
    public static class Menus
    {
        public static readonly Menu ContactTypeMenu = new Menu()
        {
            Name = "Contact Type Menu",
            Items = new List<MenuItem>() {
                new MenuItem() { Command = "L", Value = "List", MethodToExecute = ContactTypeLogic.CommandContactTypeList},
                new MenuItem() { Command = "C", Value = "Create", MethodToExecute = null},
                new MenuItem() { Command = "R", Value = "Read", MethodToExecute = null},
                new MenuItem() { Command = "U", Value = "Update", MethodToExecute = null},
                new MenuItem() { Command = "D", Value = "Delete", MethodToExecute = null},
            }
        };

        public static readonly Menu PersonMenu = new Menu()
        {
            Name = "Person Menu",
            Items = new List<MenuItem>() {
                new MenuItem() { Command = "L", Value = "List", MethodToExecute = PersonLogic.CommandPersonList},
                new MenuItem() { Command = "C", Value = "Create", MethodToExecute = PersonLogic.CommandPersonCreate},
                new MenuItem() { Command = "R", Value = "Read", MethodToExecute = PersonLogic.CommandPersonRead},
                new MenuItem() { Command = "U", Value = "Update", MethodToExecute = null},
                new MenuItem() { Command = "D", Value = "Delete", MethodToExecute = PersonLogic.CommandPersonDelete},
            }
        };

        public static readonly Menu ContactMenu = new Menu()
        {
            Name = "Contact Menu",
            Items = new List<MenuItem>() {
                new MenuItem() { Command = "L", Value = "List", MethodToExecute = ContactLogic.CommandContactList},
                new MenuItem() { Command = "C", Value = "Create", MethodToExecute = null},
                new MenuItem() { Command = "R", Value = "Read", MethodToExecute = null},
                new MenuItem() { Command = "U", Value = "Update", MethodToExecute = null},
                new MenuItem() { Command = "D", Value = "Delete", MethodToExecute = null},
            }
        };

        public static readonly Menu MainMenu = new Menu()
        {
            Name = "Main Menu",
            Items = new List<MenuItem>()
            {
                new MenuItem() { Command = "I", Value = "Initialize database", MethodToExecute = null},
                new MenuItem() { Command = "T", Value = "Contact type CRUD", MethodToExecute = ContactTypeMenu.DoMenu},
                new MenuItem() { Command = "P", Value = "Person CRUD", MethodToExecute = PersonMenu.DoMenu},
                new MenuItem() { Command = "C", Value = "Contact CRUD", MethodToExecute = ContactMenu.DoMenu},
            }
        };

    }
}
