﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DAL;
using Domain;

namespace ConsoleApp
{
    public static class PersonLogic
    {
        public static void CommandPersonRead(DbContext db)
        {
            var p = db.Persons.FirstOrDefault(x => x.FirstName.ToLower() == "andres");
            if (p == null)
            {
                Console.WriteLine("No persons in db!");
                return;
            }

            Console.WriteLine(p);
            foreach (var pContact in p.Contacts)
            {
                Console.WriteLine($"    {pContact}");
            }
        }

        public static void CommandPersonDelete(DbContext db)
        {
            if (db.Persons.Count == 0)
            {
                Console.WriteLine("List is empty!");
                return;
            }

            CommandPersonList(db);
            Console.WriteLine("Give the number of record to delete (0 to cancel):");
            var command = Console.ReadLine().Trim();
            if (command != "0")
            {
                //var recordNoDoDelete = int.Parse(command) - 1;
                var recordNoDoDelete = 0;
                if (int.TryParse(command, out recordNoDoDelete))
                {
                    recordNoDoDelete = recordNoDoDelete - 1;
                    if (recordNoDoDelete < 0 || (db.Persons.Count - 1) < recordNoDoDelete)
                    {
                        Console.WriteLine("No such element in list!");
                    }
                    else
                    {
                        Console.Write("Deleting record no: " + recordNoDoDelete);
                        db.Persons.RemoveAt(recordNoDoDelete);
                        Console.WriteLine(" done!");
                    }
                }
                else
                {
                    Console.WriteLine("Please enter an number!");
                }
            }

        }

        public static void CommandPersonCreate(DbContext db)
        {
            Console.WriteLine();
            Console.Write("First name:");
            var firstName = Console.ReadLine();
            Console.Write("Last name:");
            var lastName = Console.ReadLine();

            try
            {
                db.Persons.Add(new Person()
                {
                    FirstName = firstName,
                    LastName = lastName
                });
                Console.WriteLine("Person added. Count in db: " + db.Persons.Count);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error during insertion! Message:" + ex.Message);
            }

            Console.WriteLine();
        }

        public static void CommandPersonList(DbContext db)
        {
            Console.WriteLine();
            Console.WriteLine("Count: " + db.Persons.Count);
            var counter = 1;
            foreach (var dbPerson in db.Persons)
            {
                Console.WriteLine($"No {counter} - {dbPerson}");
                counter++;
            }
        }
    }
}
